/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY codergen. EDIT WITH CARE.
 */
package com.android.tools.idea.editors.gfxtrace.service.log;

import org.jetbrains.annotations.NotNull;
import com.android.tools.rpclib.binary.Decoder;
import com.android.tools.rpclib.binary.Encoder;
import java.io.IOException;

public final class Severity {
  public static final int Emergency = 0;
  public static Severity emergency() { return new Severity(Emergency); }
  public static final int Alert = 1;
  public static Severity alert() { return new Severity(Alert); }
  public static final int Critical = 2;
  public static Severity critical() { return new Severity(Critical); }
  public static final int Error = 3;
  public static Severity error() { return new Severity(Error); }
  public static final int Warning = 4;
  public static Severity warning() { return new Severity(Warning); }
  public static final int Notice = 5;
  public static Severity notice() { return new Severity(Notice); }
  public static final int Info = 6;
  public static Severity info() { return new Severity(Info); }
  public static final int Debug = 7;
  public static Severity debug() { return new Severity(Debug); }

  public final int value;

  public Severity(int value) {
    this.value = value;
  }

  public void encode(@NotNull Encoder e) throws IOException {
    e.int32(value);
  }

  public static Severity decode(@NotNull Decoder d) throws IOException {
    int value = d.int32();
    return new Severity(value);
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || !(o instanceof Severity)) return false;
    return value == ((Severity)o).value;
  }

  @Override
  public int hashCode() {
    return value;
  }

  @Override
  public String toString() {
    switch(value) {
      case Emergency: return "Emergency";
      case Alert: return "Alert";
      case Critical: return "Critical";
      case Error: return "Error";
      case Warning: return "Warning";
      case Notice: return "Notice";
      case Info: return "Info";
      case Debug: return "Debug";
      default: return "Severity(" + value + ")";
    }
  }
}
